<template>
    <b-row>
        <template v-if="ShouldDisplayArrows">
            <b-col md="1" class="p-0">
                <b-button @click="onLeftClick" variant="transparent" class="my-auto h-100 w-100">
                    <b-icon-capslock rotate="-90" scale="1.3"></b-icon-capslock>
                </b-button>
            </b-col>
        </template>
        <template v-else>
            <b-col md="1">
            </b-col>
        </template>
        <b-col md="10" class="p-0">
            <b-carousel :id="CarouselID" ref="CarouselRef" :interval="0">

                <template v-if="!AtLeastOneSlide">
                    <b-carousel-slide img-blank img-alt="Title">
                        <template #img>
                            <div class="d-flex justify-content-center align-content-baseline" style="height: 200px">
                                <h1 class="my-auto text-center">{{ Name }}</h1>
                            </div>
                        </template>
                    </b-carousel-slide>
                </template>
                <template v-else>
                    <template v-for="(slide, index) in Slides">
                        <template v-if="slide.type === 'image'">
                            <b-carousel-slide :key="index" :img-src="images['/src/assets/projects/' + slide.src].default" />
                        </template>
                        <template v-else-if="slide.type === 'video'">
                            <b-carousel-slide :key="index">
                                <template #img>
                                    <b-embed type="iframe" aspect="16by9" allowfullscreen :src="slide.src" />
                                </template>
                            </b-carousel-slide>
                        </template>
                        <template v-else-if="slide.type === 'gif'">
                            <b-carousel-slide :key="index">
                                <template #img>
                                    <b-img :src="images['/src/assets/projects/' + slide.src].default" 
                                            fluid center :alt="slide.src" />
                                </template>
                            </b-carousel-slide>
                        </template>
                        <template v-else>
                            <b-carousel-slide :key="index" img-blank img-alt="Title">
                                <template #img>
                                    <div class="d-flex justify-content-center align-content-baseline" style="height: 200px">
                                        <h1 class="my-auto text-center">Woopsie!</h1>
                                    </div>
                                </template>
                            </b-carousel-slide>
                        </template>
                    </template>
                </template>

            </b-carousel>
        </b-col>
        <template v-if="ShouldDisplayArrows">
            <b-col md="1" class="p-0">
                <b-button @click="onRightClick" variant="transparent" class="my-auto h-100 w-100">
                    <b-icon-capslock rotate="90" scale="1.3"></b-icon-capslock>
                </b-button>
            </b-col>
        </template>
    </b-row>
</template>

<script>
import images from '../images.js';

export default {
    props: {
        Name: String,
        Slides: Array
    },
    methods: {
        onLeftClick () {
            this.$refs.CarouselRef.prev();
        },
        onRightClick () {
            this.$refs.CarouselRef.next();
        }
    },
    created () {
        this.images = images.ProjectsImages;
        this.CarouselID = 'carousel-' + this.Name.replace(/\W+/g, '-').toLowerCase();
        this.AtLeastOneSlide = this.Slides != undefined;
        this.ShouldDisplayArrows = this.AtLeastOneSlide && this.Slides.length > 1;
    }
};
</script>

<style scoped>
    .btn {
        box-shadow: none !important;
        color:#888
    }
        .btn:hover {
            color: #212529;
            font-size: 1.25rem;
        }
        .btn:active {
            font-size: 1.05rem;
        }
</style>